Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class LifecyclePolicyEntry

    java.lang.Object
      oracle.ifs.beans.LibraryObject
          oracle.ifs.beans.TieLibraryObject
              oracle.ifs.beans.SystemObject
                  oracle.ifs.beans.TieSystemObject
                      oracle.ifs.beans.SystemCategory
                          oracle.ifs.beans.TieSystemCategory
                              oracle.ifs.beans.LifecyclePolicyEntry

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, SystemObjectInterface, Traceable

Direct Known Subclasses:
  TieLifecyclePolicyEntry

    public class LifecyclePolicyEntry

extends TieSystemCategory

A LifecyclePolicyEntry represents actions to be executed as part of a LifecyclePolicy.

(Unpublished)

Field Summary
`static java.lang.String` | `AGENTIDENTIFIER_PROPERTY` The name of the String property (in the instance's PropertyBundle) of the identifier of the agent instance that is responsible for processing this LifecyclePolicyEntry.
`static java.lang.String` | `BASETIMEOFDAY_PROPERTY` The name of the String property (in the instance's PropertyBundle) of the base time-of-day to compute the time to search for Documents that are eligible to have this action performed on them.
`static java.lang.String` | `CLASS_NAME` The name of the ClassObject representing this class.
`static java.lang.String` | `DESCRIPTION_ATTRIBUTE` The name of the attribute that holds the description of this LifecyclePolicyEntry.
`static java.lang.String` | `ENABLED_ATTRIBUTE` The name of the attribute that indicates whether documents should continue to end up in the state reflected by this entry.
`static java.lang.String` | `EXECUTIONPERIOD_PROPERTY` The name of the String property (in the instance's PropertyBundle) of the time period to search for Documents that are eligible to have this action performed on them.
`static java.lang.String` | `FROZEN_ATTRIBUTE` The name of the attribute that indicates whether the processing for this entry has been suspended (frozen).
`static java.lang.String` | `LIFECYCLEPOLICYACTIONSPECIFICATION_ATTRIBUTE` The name of the attribute that references the action specification to execute.
`static java.lang.String` | `LIFECYCLESEQUENCE_ATTRIBUTE` The name of the attribute that holds the sequence of this entry within the set of LifecyclePolicyEntries for the LifecyclePolicy (1-based).
`static java.lang.String` | `NAME_ATTRIBUTE` The name of the attribute that holds the name of this LifecyclePolicyEntry (optional).
`static java.lang.String` | `THREADGROUP_PROPERTY` The name of the String property (in the instance's PropertyBundle) of the thread group value to be used to balance the execution within LifecycleAgent.
`static java.lang.String` | `TIMEPERIOD_ATTRIBUTE` The name of the attribute that holds the time period since the document's LifecycleDate when this action should be executed (String[32]).

Fields inherited from class oracle.ifs.beans.SystemCategory
`ASSOCIATEDSYSTEMOBJECT_ATTRIBUTE`

Fields inherited from class oracle.ifs.beans.SystemObject
`ACTIVE_ATTRIBUTE, POLICYBUNDLE_ATTRIBUTE, POLICYLISTS_ATTRIBUTE, PROPERTYBUNDLE_ATTRIBUTE`

Fields inherited from class oracle.ifs.beans.LibraryObject
`DOMAIN_UNIQUENAME_DEFAULT_DELIMITER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `LifecyclePolicyEntry(LibrarySession session, java.lang.Long id, java.lang.Long classId, S_LibraryObjectData data)` Construct a LifecyclePolicyEntry object.

Method Summary
`protected static LifecyclePolicyEntry[]` | `constructLifecyclePolicyEntryArray(LibrarySession sess, java.lang.Long[] ids)` Constructs a LifecyclePolicyEntry array from an array of object IDs.
`java.lang.String` | `getAgentIdentifierProperty()` Returns the identifier of the agent instance that is responsible for processing this LifecyclePolicyEntry.
`java.lang.String` | `getBaseTimeOfDayProperty()` Gets the base time-of-day for computing the time to search for Documents that are eligible to have this action performed on them.
`java.lang.String` | `getDescription()` Gets the description of this LifecyclePolicyEntry.
`java.lang.String` | `getExecutionPeriodProperty()` Returns the time period to search for Documents that are eligible to have this action performed on them.
`LifecyclePolicy` | `getLifecyclePolicy()` Gets the LifecyclePolicy that this entry is part of.
`LifecyclePolicyActionSpecification` | `getLifecyclePolicyActionSpecification()` Gets the references of the LifecyclePolicyActionSpecification that will be used to execute the action.
`static LifecyclePolicyEntry[]` | `getLifecyclePolicyEntries(LibrarySession session)` Returns the set of defined LifecyclePolicyEntry instances.
`int` | `getLifecycleSequence()` Gets the sequence of this entry within the set of LifecyclePolicyEntries for the LifecyclePolicy (1-based).
`int` | `getLifecycleState()` Gets the lifecycle state that should be used after execution of the associated action.
`LifecyclePolicyEntry` | `getPreviousLifecyclePolicyEntry()` Gets the LifecyclePolicyEntry that is immediate before this entry in the list of LifecyclePolicyEntry objects for the LifecyclePolicy.
`java.lang.Integer` | `getThreadGroupProperty()` Returns the thread group value to be used to balance the execution within LifecycleAgent.
`java.lang.String` | `getTimePeriod()` Gets the time period since the document's LifecycleDate when this action should be executed.
`boolean` | `hasNameAttribute()` Returns true if this object is an instance of a class that has a NAME attribute, and false otherwise.
`boolean` | `isEnabled()` Returns true if the entry is enabled.
`boolean` | `isFrozen()` Returns true if the entry is suspended (frozen).
`protected void` | `preCreate(LibraryObjectDefinition lodef)` Extensibility point to perform actions prior to the creation of a PublicObject.
`protected void` | `preFree(LibraryObjectDefinition lodef)` Extensibility point to perform actions prior to the permanent deletion ("free") of a object.
`protected void` | `preUpdate(LibraryObjectDefinition lodef)` Extensibility point to perform actions prior to the update of a PublicObject.
`protected void` | `validatePropertyValues(PropertyDefinition[] propDefs)` Validates Properties specified during create or update operations.

Methods inherited from class oracle.ifs.beans.SystemCategory
`constructCategoryArray, constructCategoryVector, constructSystemCategory, getAssociatedSystemObject`

Methods inherited from class oracle.ifs.beans.SystemObject
`addCategory, constructSystemObject, constructSystemObjectVector, free, freeCategories, getCategories, getCategories, getCategories, getCategories, getPolicyBundle, getPolicyLists, handleCreate, isActive, postCreate, postUpdate, putPolicy, removeAllPolicies, removePolicy, removePolicy, setActive, setPolicyBundle, setPolicyLists`

Methods inherited from class oracle.ifs.beans.LibraryObject
`applyProperties, auditCreated, auditUpdated, checkRequiredAttributeSet, clearCopyContext, clearFreeContext, clearUpdateContext, constructIdArray, constructIdArray, constructLibraryObject, constructLibraryObjectVector, createDedicatedPropertyBundle, deriveDomainUniqueName, dispose, equals, free, get, getAttribute, getAttributeByUpperCaseName, getAttributes, getAttributesByUpperCaseNames, getAuditDomainContext, getAuditEventFolderContext, getClassId, getClassname, getClassName, getClassObject, getCommonName, getCopyContext, getCreateContext, getData, getDefinition, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getFreeContext, getId, getLabel, getName, getObjectReferenceAttribute, getOperationActionSpecificationContext, getPropertyBundle, getPropertyValue, getPublicObjectAttribute, getResourceString, getResourceString, getSchemaObjectAttribute, getSession, getSessionInterface, getSharedStateFactory, getStringIdentifier, getSystemObjectAttribute, getTraceLogger, getUpdateContext, handleAdminModeChange, handleEvent, handleFree, handleUpdate, hashCode, invokeOperation, invokeOperation, invokeServerMethod, isConnected, isCoreEventPostingEnabled, isInstanceOf, isTraced, isValidEventType, lockRows, lookupInstanceLabel, postEvent, postEvent, postFree, prePostAuditEvent, putProperty, putProperty, removeAllProperties, removeProperty, renderAsRandomAccessContent, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, setAttributes, setCopyContext, setFreeContext, setId, setName, setPropertyBundle, setPropertyValue, setUpdateContext, toString, trace, trustHandleCreate, trustHandleCreateAsAdmin, trustHandleFree, trustHandleFreeAsAdmin, trustHandleUpdate, trustHandleUpdateAsAdmin, update, updateAndExposeDefinition, vectorLibraryObjectElement, vectorToLibraryObjectArray, verifyAdministrationMode, verifyConnected, verifySystemUserAccess, verifyTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

  Description copied from class: `LifecyclePolicyEntry`
  The name of the ClassObject representing this class.

  See Also:
    Constant Field Values
  (Published)

### NAME_ATTRIBUTE

    public static final java.lang.String NAME_ATTRIBUTE

  Description copied from class: `LifecyclePolicyEntry`
  The name of the attribute that holds the name of this LifecyclePolicyEntry (optional). (String[700])

  See Also:
    Constant Field Values

### DESCRIPTION_ATTRIBUTE

    public static final java.lang.String DESCRIPTION_ATTRIBUTE

  Description copied from class: `LifecyclePolicyEntry`
  The name of the attribute that holds the description of this LifecyclePolicyEntry. (String[2000])

  See Also:
    Constant Field Values

### LIFECYCLESEQUENCE_ATTRIBUTE

    public static final java.lang.String LIFECYCLESEQUENCE_ATTRIBUTE

  Description copied from class: `LifecyclePolicyEntry`
  The name of the attribute that holds the sequence of this entry within the set of LifecyclePolicyEntries for the LifecyclePolicy (1-based). (Integer)

  See Also:
    Constant Field Values

### ENABLED_ATTRIBUTE

    public static final java.lang.String ENABLED_ATTRIBUTE

  Description copied from class: `LifecyclePolicyEntry`
  The name of the attribute that indicates whether documents should continue to end up in the state reflected by this entry. (Boolean)

  See Also:
    Constant Field Values

### LIFECYCLEPOLICYACTIONSPECIFICATION_ATTRIBUTE

    public static final java.lang.String LIFECYCLEPOLICYACTIONSPECIFICATION_ATTRIBUTE

  Description copied from class: `LifecyclePolicyEntry`
  The name of the attribute that references the action specification to execute. (SystemObject)

  See Also:
    Constant Field Values

### TIMEPERIOD_ATTRIBUTE

    public static final java.lang.String TIMEPERIOD_ATTRIBUTE

  Description copied from class: `LifecyclePolicyEntry`
  The name of the attribute that holds the time period since the document's LifecycleDate when this action should be executed (String[32]).

  The value format is a number with an optional time unit suffix. The supported case-insensitive suffices are:

  - D - indicating days
  - H - indicating hours
  - M - indicating minutes
  - S - indicating seconds
  If none of these suffices are present in the string, the value must represent an integer, representing the number of millisenconds for the execution period.

  For example, the string "12H" represents a timeout period of twelve hours, "365d" represents 365 days, and "3500000" represents 3500000 milliseconds.

  See Also:
    Constant Field Values

### FROZEN_ATTRIBUTE

    public static final java.lang.String FROZEN_ATTRIBUTE

  Description copied from class: `LifecyclePolicyEntry`
  The name of the attribute that indicates whether the processing for this entry has been suspended (frozen). (Boolean)

  See Also:
    Constant Field Values

### EXECUTIONPERIOD_PROPERTY

    public static final java.lang.String EXECUTIONPERIOD_PROPERTY

  Description copied from class: `LifecyclePolicyEntry`
  The name of the String property (in the instance's PropertyBundle) of the time period to search for Documents that are eligible to have this action performed on them.

  See `TIMEPERIOD_ATTRIBUTE` for the definition of the time format.

  A null value indicates the default value for the LifecycleAgent will be used.

  See Also:
    Constant Field Values

### BASETIMEOFDAY_PROPERTY

    public static final java.lang.String BASETIMEOFDAY_PROPERTY

  Description copied from class: `LifecyclePolicyEntry`
  The name of the String property (in the instance's PropertyBundle) of the base time-of-day to compute the time to search for Documents that are eligible to have this action performed on them.

  Format is "HH:mm:ss" using a 24 hour clock. For example "13:00:00" indicates that the base time-of-day is 1:00 pm in the default Timezone.

  If not specified, the default value for the LifecycleAgent will be used.

  See Also:
    Constant Field Values

### AGENTIDENTIFIER_PROPERTY

    public static final java.lang.String AGENTIDENTIFIER_PROPERTY

  Description copied from class: `LifecyclePolicyEntry`
  The name of the String property (in the instance's PropertyBundle) of the identifier of the agent instance that is responsible for processing this LifecyclePolicyEntry.

  Can be null, in which case the default agent will process.

  See Also:
    Constant Field Values

### THREADGROUP_PROPERTY

    public static final java.lang.String THREADGROUP_PROPERTY

  Description copied from class: `LifecyclePolicyEntry`
  The name of the String property (in the instance's PropertyBundle) of the thread group value to be used to balance the execution within LifecycleAgent.

  Can be null, in which case a value is generated from the instance's ID.

  See Also:
    Constant Field Values

Constructor Detail

### LifecyclePolicyEntry

    protected LifecyclePolicyEntry(LibrarySession session,
                                   java.lang.Long id,
                                   java.lang.Long classId,
                                   S_LibraryObjectData data)
                            throws IfsException

  Construct a LifecyclePolicyEntry object.

  Parameters:
    `session` - current LibrarySession
    `id` - object id
    `classId` - class id
    `data` - data component
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

Method Detail

### hasNameAttribute

    public boolean hasNameAttribute()
                             throws IfsException

  Description copied from class: `LibraryObject`
  Returns true if this object is an instance of a class that has a NAME attribute, and false otherwise.

  Overrides:
    `hasNameAttribute` in class `LibraryObject`
  Returns:
    true if the object has a NAME attribute.
  Throws:
    `IfsException` - if operation fails.

### getDescription

    public java.lang.String getDescription()
                                    throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Gets the description of this LifecyclePolicyEntry.

  Returns:
    the object description
  Throws:
    `IfsException` - if operation fails

### getLifecyclePolicy

    public LifecyclePolicy getLifecyclePolicy()
                                       throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Gets the LifecyclePolicy that this entry is part of.

  Returns:
    the parent LifecyclePolicy
  Throws:
    `IfsException` - if operation fails

### getPreviousLifecyclePolicyEntry

    public LifecyclePolicyEntry getPreviousLifecyclePolicyEntry()
                                                         throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Gets the LifecyclePolicyEntry that is immediate before this entry in the list of LifecyclePolicyEntry objects for the LifecyclePolicy.

  Returns null if this is the first entry in the list.

  Returns:
    the previous LifecyclePolicyEntry
  Throws:
    `IfsException` - if operation fails

### getLifecycleState

    public int getLifecycleState()
                          throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Gets the lifecycle state that should be used after execution of the associated action.

  Returns:
    the lifecycle state corresponding to this instance
  Throws:
    `IfsException` - if operation fails

### getLifecycleSequence

    public int getLifecycleSequence()
                             throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Gets the sequence of this entry within the set of LifecyclePolicyEntries for the LifecyclePolicy (1-based).

  Returns:
    the lifecycle sequence corresponding to this instance
  Throws:
    `IfsException` - if operation fails

### isEnabled

    public boolean isEnabled()
                      throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Returns true if the entry is enabled.

  If a LifecyclePolicyEntry is not enabled, documents will skip that step as they progress through the lifecycle policy entries.

  Returns:
    true if the entry is enabled
  Throws:
    `IfsException` - if the operation fails

### isFrozen

    public boolean isFrozen()
                     throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Returns true if the entry is suspended (frozen).

  If a LifecyclePolicyEntry is frozen, processing will not occur for documents that are waiting for this step to occur.

  Returns:
    true if the entry is enabled
  Throws:
    `IfsException` - if the operation fails

### getLifecyclePolicyActionSpecification

    public LifecyclePolicyActionSpecification getLifecyclePolicyActionSpecification()
                                                                             throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Gets the references of the LifecyclePolicyActionSpecification that will be used to execute the action.

  Returns:
    the LifecyclePolicyActionSpecification
  Throws:
    `IfsException` - if operation fails

### getTimePeriod

    public java.lang.String getTimePeriod()
                                   throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Gets the time period since the document's LifecycleDate when this action should be executed.

  The value's format is a number with an optional time unit suffix. The supported case-insensitive suffices are:

  - D - indicating days
  - H - indicating hours
  - M - indicating minutes
  - S - indicating seconds
  If none of these suffices are present in the string, the value must represent an integer, representing the number of millisenconds for the execution period.

  For example, the string "12H" represents a timeout period of twelve hours, "365d" represents 365 days, and "3500000" represents 3500000 milliseconds.

  Returns:
    the time period
  Throws:
    `IfsException` - if operation fails

### getExecutionPeriodProperty

    public java.lang.String getExecutionPeriodProperty()
                                                throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Returns the time period to search for Documents that are eligible to have this action performed on them.

  The value returned is a number with an optional time unit suffix. The supported case-insensitive suffices are:

  - D - indicating days
  - H - indicating hours
  - M - indicating minutes
  - S - indicating seconds
  If none of these suffices are present in the string, the value must represent an integer, representing the number of millisenconds for the timeout period.

  For example, the string "4H" represents a timeout period of four hours, "3d" represents threee days, and "3500" represents 3500 milliseconds.

  A null value indicates that the default should be used.

  Returns:
    the execution period
  Throws:
    `IfsException` - if the operation fails.

### getBaseTimeOfDayProperty

    public java.lang.String getBaseTimeOfDayProperty()
                                              throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Gets the base time-of-day for computing the time to search for Documents that are eligible to have this action performed on them.

  Is a string representation of the base time of day relative to the timezone default for the default Domain, using a 24-hour clock format. For example, this method returns "18:30:00" if the base time of day is meant to be 6:30 p.m.

  If null is returned, a default base time of day should be used (typically "00:00:00").

  Returns:
    the base time of day, or null if a default should be used
  Throws:
    `IfsException` - if the operation fails.

### getAgentIdentifierProperty

    public java.lang.String getAgentIdentifierProperty()
                                                throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Returns the identifier of the agent instance that is responsible for processing this LifecyclePolicyEntry.

  Can be null, in which case the default agent will process.

  Returns:
    the agent identifier, or null if the default agent should process
  Throws:
    `IfsException` - if the operation fails.

### getThreadGroupProperty

    public java.lang.Integer getThreadGroupProperty()
                                             throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Returns the thread group value to be used to balance the execution within LifecycleAgent.

  Can be null, in which case the ID is used to compute a thread group value.

  Returns:
    the thread group value, or null if a value should be generated from the instance's ID
  Throws:
    `IfsException` - if the operation fails.

### getLifecyclePolicyEntries

    public static LifecyclePolicyEntry[] getLifecyclePolicyEntries(LibrarySession session)
                                                            throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Returns the set of defined LifecyclePolicyEntry instances.

  Parameters:
    `session` - the session context
  Returns:
    the set of LifecyclePolicyEntry instances; returns an empty array if there are none
  Throws:
    `IfsException` - if the operation fails.

### preCreate

    protected void preCreate(LibraryObjectDefinition lodef)
                      throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Extensibility point to perform actions prior to the creation of a PublicObject.

  Set an option that indicates that Categories are NOT to be created from within S_SystemObject.

  Overrides:
    `preCreate` in class `SystemObject`
  Parameters:
    `lodef` - object definition that will be used to create the object
  Throws:
    `IfsException` - if operation fails

### preUpdate

    protected void preUpdate(LibraryObjectDefinition lodef)
                      throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Extensibility point to perform actions prior to the update of a PublicObject.

  Set an option that indicates that Categories are NOT to be created from within S_SystemObject.

  Overrides:
    `preUpdate` in class `SystemObject`
  Parameters:
    `lodef` - definition used to define how the target object will be updated
  Throws:
    `IfsException` - if operation fails

### preFree

    protected void preFree(LibraryObjectDefinition lodef)
                    throws IfsException

  Description copied from class: `LibraryObject`
  Extensibility point to perform actions prior to the permanent deletion ("free") of a object.

  This method is typically overridden by subclasses that perform other operations prior to the target object being freed in order to all delete or modify objects related to the target object. Subclasses are expected to invoke `super.preFree`.

  Overrides:
    `preFree` in class `LibraryObject`
  Parameters:
    `lodef` - object definition used to hold options related to the free operation
  Throws:
    `IfsException` - if operation fails.

### validatePropertyValues

    protected void validatePropertyValues(PropertyDefinition[] propDefs)
                                   throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Validates Properties specified during create or update operations.

  Overrides:
    `validatePropertyValues` in class `LibraryObject`
  Parameters:
    `propDefs` - The Property definitions
  Throws:
    `IfsException` -
    31601: if a name or value is not specified for a property
    other: if the operation otherwise fails

### constructLifecyclePolicyEntryArray

    protected static LifecyclePolicyEntry[] constructLifecyclePolicyEntryArray(LibrarySession sess,
                                                                               java.lang.Long[] ids)
                                                                        throws IfsException

  Description copied from class: `LifecyclePolicyEntry`
  Constructs a LifecyclePolicyEntry array from an array of object IDs. This will throw an exception if any of the IDs cannot be converted into a LifecyclePolicyEntry object.

  Parameters:
    `sess` - the session context
    `ids` - the array of object IDs
  Returns:
    the array of LifecyclePolicyEntry instances
  Throws:
    `IfsException` - if operation fails.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD